<?php
namespace FiloBlu\Flow\Model\Channel\In;


class Ite extends AbstractModel {

    /**
    * @var \Monolog\Logger
    */
    protected $_logger;

    public function __construct(
             \FiloBlu\Flow\Helper\LoggerProvider $loggerProvider,
             \FiloBlu\Flow\Model\Channel\Config $channelConfig
    ) {
        parent::__construct($loggerProvider, $channelConfig);
        $this->_logger = $loggerProvider->getLogger();
    }

    public function load($channelname) {
        $this->init($channelname);
    }

    public function insertData($data) {
            
        // Genero il FLusso ITEMS

        $parser = $this->getParser();
        $check_mapping_count = $parser->check_mapping_count;

        $flow = $this->getFile()->getData('flow');
        $model =  \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model' . "\\" . $flow);

        if (!$model)
            return false;

        $model->setData('meta_file',$this->getFile()->getId());
        //set fascia iva articoli da configurazione
        $model->setData('fascia_iva_articoli','STD');
        $model->setData('meta_processed',0);
        $model->setData('meta_insert_time',date('Y-m-d H:i:s'));
        foreach($data as $field => $value){

            // Have a json mapping?
            if(isset($this->map) && $this->map){

                // Get the mapping
                $fieldMap = $this->map->get($field);
                // I need to skip this?
                if(!isset($fieldMap["skip"])) {
                    // Have a destination field? Set that as a "to field"
                    if(isset($fieldMap["to"]) && $fieldMap["to"]){
                        $to_field = $fieldMap["to"];
                        $model->setData("$to_field","$value");
                    // Don't have a destination field but the check_mapping_count is off? Fallback to column name
                    } elseif (!$check_mapping_count){
                        $model->setData("$field","$value");
                    }
                }

            // No json mapping here
            } else {

                // No json and no check then the column name is the field name
                if(!$check_mapping_count){
                    $model->setData("$field","$value");
                } else {
                    // nothing to do here.
                }
            }

        }

        //If Product is only simple I need to reset configurable_attributes and configurable_values. This prevents the creation of wrong configurable product of simple
        if(empty($model->getCodiceConfigurabile()) || trim($model->getCodiceConfigurabile()) === trim($model->getCodiceArticolo())){
            $model->setData('configurable_attributes',null);
            $model->setData('configurable_values',null);
        }

        $model->save();
    }

}
